//#include "triangles.h"
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
using namespace std;
#define ll long long
#define ld long double
const ll INF = 1e18;
const int MOD = 1e9 + 7;
void solve() {
	int t; cin >> t;
	int n, m; cin >> n >> m;
	vector <int> a(n); for (int i = 0; i < n; ++i) cin >> a[i];
	string s; cin >> s;
	if (m % 2 == 0) {
		cout << "No\n";
		return;
	}
	else
		cout << "Yes\n";
	if (t == 1) 
		return;
	cout << (m + 1) / 2 << "\n";
	if (t == 2) 
		return;
	cout << 1 << "\n";
	cout << (m + 1) / 2 - 1 << " " << (m + 1) / 2 << "\n";
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int TESTS = 1; //cin >> TESTS;
	while (TESTS--) solve();
}
